/* xlevel.h : Audio Level Meter for X11 (Linux and FreeBSD)
 * programmed by K. Takebe, 1997/11/02
 */
#ifndef _XLEVEL_H_
#define _XLEVEL_H_

#define XLEVEL_VERSION   "0.3"

#define DEFAULT_DSP_DEVICE    "/dev/dsp"
#define DEFAULT_MIXER_DEVICE  "/dev/mixer"

/* default string for X11 Resource */
#define UPDATE         "80"       /* default update time [msec] */
#define N_PEAK         "10"       /* default peak keep time */
#define S_RATE         "44100"    /* default sampling freq. */
#define N_IND          "12"       /* number of indicator */ 
#define N_SPEC         "8"        /* number of freq.-band */
#define OVER_RATIO     "75"       /* ratio of over-level vs. max-level*/
#define N_DAT          "512"      /* default sampling buffer size */

#define COLOR_NORMAL  "green"
#define COLOR_OVER    "red"
#define COLOR_NONE    "gray30"
#define COLOR_BACK    "Black"


#define UNIT_WIDTH     "16"
#define UNIT_HEIGHT    "4"
#define UNIT_MARGIN    "2"


/* indicators and freq-bands min.- max. values */
#define MIN_INDICATORS 5
#define MAX_INDICATORS 32
#define MIN_FREQBANDS  5
#define MAX_FREQBANDS  32

/* sampling buffer size and dma-dvisor */
#define DMA_DIV        4          /* DMA dvisor */
#define NDAT_MAX       1024
#define NDAT_MIN       64

#ifndef M_PI
#define M_PI 3.14159265358979
#endif


/* in xlevel.c */
extern int     debug;
extern int     verbose;
extern int     nInd;
extern int     nOver;
extern int     nSpec;
extern int     nDat;
extern char    dsp_device[80];
extern char    mixer_device[80];

/* in fft.c */
extern int     init_fft_param(int n);
extern int     fft1(double *ar, double *ai);

/* in sound.c */
extern int     sampling;
extern void    init_sampling_buffer();  
extern void    init_sound_card(char *devicename);
extern int     close_sound_device();
extern void    get_data();

/* in sampling.c */
extern void    init_level_trans_table();
extern int     init_spectrum_buffer();
extern void    store_level_data();
extern void    get_level(int *left, int *right);
extern void    store_spectrum_data();
extern void    get_spectrum(int *left, int *right);

/* in mixing.c */
extern int     close_mixer_device();
extern int     mixer_setting(char *mixer, char *rec_devices);
extern int     check_available_devices(char *mixer, char *devices);

/* in interval.c */
extern void     store_start_time();
extern long int get_spend_time();

#endif /* _XLEVEL_H_ */
